<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - A Simple Example</TITLE>
<link href="builder_5.html" rel=Next>
<link href="builder_3.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_3.html">previous</A>, <A HREF="builder_5.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC4" HREF="builder_toc.html#TOC4">A Simple Example of What the Builder Can Do</A></H2>

<P>
This is a complete example of a SUIF pass that will modify 
programs. 

</P>
<P>
Assume that this pass must add a special local variable to each
procedure in the input program.  This variable needs to hold a special
value while the procedure is active.  The lower 6 bits of this value
should hold an unique identifier number of the procedure, the next 9
bits hold the initial value of the first parameter and the highest bit
should be one. If any of those numbers overflow, the value should be
zero.  Note that overflowing of the unique identifier can be calculated
at compile time but the first parameter needs to be checked at runtime.
Assume each procedure has at least one parameter and that the first
parameter is an integer.

</P>


<H3><A NAME="SEC5" HREF="builder_toc.html#TOC5">main.cc</A></H3>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;
#include &#60;builder.h&#62;

int UID;

void do_proc(tree_proc * tp)
{
    block::set_proc(tp);

    sym_node_list * snl = tp-&#62;proc_syms()-&#62;params();
    assert(snl-&#62;count() &#62; 0);
    assert((*snl)[0]-&#62;is_var());
    var_sym * first_param = (var_sym *)(*snl)[0];

    block fp_var(first_param);

    type_node * type = block::parse_type("int32");

    block num_var(block::new_sym(type, "proc_id")); 
     
    block setid;
    if(UID &#60;= 0x3F) {
        block count(UID);

        setid.set(block::IF((fp_var &#60;= block(0x1FF)),
                            (num_var = block(0x8000) + 
                                       fp_var &#60;&#60; block(6) + 
                                       count),
                            (num_var = 0x0000)));
    } else
        setid.set(num_var = block(0x0000));

    tree_node * tn = setid.make_tree_node();

    tp-&#62;body()-&#62;push(tn);

    UID++;   
}

main(int argc, char * argv[])
{
    start_suif(argc, argv);
    UID = 0;
    suif_proc_iter(argc, argv, do_proc, TRUE, TRUE, TRUE);
}
</PRE>

<P>
<A NAME="IDX9"></A>

</P>
<P>
The above C++ program is a SUIF pass that will accomplish
this task. For all the procedures in the input program, the call to
<SAMP>`do_proc'</SAMP> will incorporate the above mentioned local variable to
the SUIF procedure. The following steps are carried-out by
<SAMP>`do_proc'</SAMP>. 

</P>

<OL>
<LI>

The SUIF procedure <SAMP>`tp'</SAMP> is initialized as the current
procedure for the builder to modify.  The <CODE>set_proc</CODE> function
should be called before any use of builder functions.

<LI>

The variable symbol of the first parameter (<SAMP>`first_param'</SAMP>) is
found. 

<LI>

The block <SAMP>`fp_var'</SAMP> holds the variable <SAMP>`first_param'</SAMP>.

<LI>

The type node for integer type is created.

<LI>

A new local integer variable named <SAMP>`proc_id'</SAMP> is created. The block
<SAMP>`num_var'</SAMP> holds this variable.

<LI>

Check if the unique number <SAMP>`UID'</SAMP> is within bounds.

<LI>

The block <SAMP>`count'</SAMP> holds the integer representing the unique number 
for the current SUIF procedure.

<LI>

The block <SAMP>`setid'</SAMP> is assigned a structure that will create the
neccessary SUIF code needed to initialize the variable. The
<CODE>IF</CODE> conditional will create a runtime check of the parameter. If
it is within bounds, the <SAMP>`num_var'</SAMP> will be set to the correct
value. Otherwise, <SAMP>`num_var'</SAMP> is set to zero at runtime. 

<LI>

It can be known at compile-time if <SAMP>`UID'</SAMP> exceeds its range. If so,
<SAMP>`num_var'</SAMP> is set to zero at runtime.

<LI>

Actually generate the SUIF code.

<LI>

Insert the SUIF code that the beginning of the current
SUIF procedure.

<LI>

Increment the <SAMP>`UID'</SAMP>.
</OL>



<H3><A NAME="SEC6" HREF="builder_toc.html#TOC6">Makefile</A></H3>
<P>
Here is the Makefile for the above pass.

</P>

<PRE>
TARGET =	ex
LIBS =		-lbuilder -lsuif -luseful -lm
SRCS =		main.cc
OBJS =		main.o 
all:		ex
install-bin:	install-prog
include $(SUIFHOME)/Makefile.std
</PRE>



<H3><A NAME="SEC7" HREF="builder_toc.html#TOC7">Building the Compiler Pass</A></H3>

<PRE>
csh&#62; gmake
g++ -c -g -Wall  -I/hawg/suif/hawg/include   main.cc
g++ -c -g -Wall  -I/hawg/suif/hawg/include   suif_init.cc
g++ -o ex -g -Wall  -I/hawg/suif/hawg/include   main.o  suif_init.o \
                 -L/hawg/suif/hawg/MIPSEL/lib  \
                 -lbuilder -lsuif -luseful -lm prog_ver.cc
</PRE>



<H3><A NAME="SEC8" HREF="builder_toc.html#TOC8">Testing the Compiler Pass</A></H3>

<P>
The SUIF pass can be tested by applying it to a few input programs.
First, the input file is compiled down to SUIF. Then the pass that
was created is applied to the input SUIF file and a resulting
SUIF file is generated.  Finally, the resulting SUIF file is
converted back to C.

</P>


<H4><A NAME="SEC9" HREF="builder_toc.html#TOC9">The Input File test.c</A></H4>

<PRE>
t0(int i)  {    }
t2(int k)  {    }
t3(int l)  {    }
...
t15(int j) {    }
...
t63(int y) {    }
t64(int x) {    }
t65(int z) {    }
</PRE>



<H4><A NAME="SEC10" HREF="builder_toc.html#TOC10">Test Session</A></H4>

<PRE>
csh&#62; scc -.sf- test.c
csh&#62; ex test.sf- test.sfx
csh&#62; s2c test.sfx &#62; test.sfx.c
</PRE>



<H4><A NAME="SEC11" HREF="builder_toc.html#TOC11">The Output File test.sfx.c</A></H4>

<PRE>
extern int t0(int i)
{
    unsigned short proc_id0;
    if (i &#60;= 511) 
        proc_id0 = 32768 + i &#60;&#60; 6 + 0;
    else 
        proc_id0 = 0;
    return 0;
}
...
extern int t15(int j)
{
    unsigned short proc_id0;
    if (j &#60;= 511)
        proc_id0 = 32768 + j &#60;&#60; 6 + 15;
    else 
        proc_id0 = 0;
    return 0;
}
...
extern int t64(int x)
{
    unsigned short proc_id0;
    proc_id0 = 0;
    return 0;
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_3.html">previous</A>, <A HREF="builder_5.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
